# <https://github.com/delapouite/kakoune-hump>

declare-option regex hump [A-Z]+(?![a-z])|[A-Z][a-z]+|[a-z]+|_[a-zA-Z0-9]+

define-command -hidden select-next-hump %{
  execute-keys h/[A-Z][a-z]+|[A-Z]+|[a-z]+<ret>
}

define-command -hidden select-previous-hump %{
  execute-keys l<a-/>[A-Z][a-z]+|[A-Z]+|[a-z]+<ret><a-semicolon>
}

define-command -hidden extend-next-hump %{
  execute-keys ?[A-Z][a-z]+|[A-Z]+|[a-z]+<ret>
}

define-command -hidden extend-previous-hump %{
  execute-keys <a-?>[A-Z][a-z]+|[A-Z]+|[a-z]+<ret>
}

map global normal <c-b> ': select-previous-hump<ret>' -docstring 'select prev hump'
map global normal <c-w> ': select-next-hump<ret>'     -docstring 'select next hump'
map global normal <c-B> ': extend-previous-hump<ret>' -docstring 'extend prev hump'
map global normal <c-W> ': extend-next-hump<ret>'     -docstring 'extend next hump'
